
function biobar_compareVersions(xmlfile, address)
{
	var path;
	var localfile = biobar_getFileObject(address, path, xmlfile);
	var xmlDoc = document.implementation.createDocument("","doc",null);
	xmlDoc.async = false;
	xmlDoc.load(localfile.spec);
	var releaseTag = xmlDoc.getElementsByTagName("database-collection");
	for (var i =0; i<releaseTag.length; i++) {
		var release = releaseTag[i].getAttribute("release");
	}
	var newDoc = document.implementation.createDocument("","xml",null);
	newDoc.async = false;
	newDoc.load(address);
	var remotereleaseTag = newDoc.getElementsByTagName("database-collection");
	if (remotereleaseTag.length == 0) {
		alert("Updating " +xmlfile+ " error. Remote file is not readable, \n or is not in text/xml format. \n Error. Will Try again later in 10 days");
		biobar_updateRunDate();
	} else {
		for (var j=0;j<remotereleaseTag.length; j++) {
			var remoteRelease = remotereleaseTag[j].getAttribute("release");
		}
		if (release == remoteRelease) {
			biobar_updateRunDate();
		} else {
			alert("Updated File "+xmlfile+" found, downloading");
			biobar_downloadFile(address,xmlfile);
			alert("local " +xmlfile+ " release version is " +release+ "\n remote File is "+remoteRelease + "restart required");
		}
	}
}

function biobar_getFileObject(address,path,xmlfile)
{
	var newfile;
	//Create Local File URI
	file=Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD",Components.interfaces.nsIFile);
	file.append(xmlfile);
	try {
		if (!file.exists()) {
			alert("File " + xmlfile + " not found in your profile. \n Downloading");
			biobar_downloadFile(address, xmlfile);
			ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			uri = ioService.newFileURI(file);
//			alert("absent " + uri);
			return(uri);
		} else {
			ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			uri = ioService.newFileURI(file);
			return(uri);
		}
	} catch(e) {
		alert(e);
	}
}

function biobar_showProfileD() {
	var path;
	alert("Your Profile Directory is " + biobar_getProfile(path));
}

function biobar_getProfile(path)
{
	const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
	try {
		path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path;
	} catch (e) {
		alert("error");
	}
	// determine the file-separator
	if (path.search(/\\/) != -1) {
		path = path + "\\";
	} else {
		path = path + "/";
	}
	return(path);
}

function biobar_downloadFile(address, xmlfile)
{
	/* From http://xul.andreashalter.ch */
	/* http://www.captain.at/programming/xul/ */

	var path;
	var savefile = biobar_getProfile(path)+ xmlfile;
//	alert(savefile);
	//new obj_URI object
	try {
		var obj_URI = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
	} catch (e) { alert(e); }

	//set obj_URI
	obj_URI.spec = address;
	//new file object
	try {
		var obj_TargetFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	} catch (e) { alert(e); }

	//set file with path
	obj_TargetFile.initWithPath(savefile);
	//if file doesn't exist, create
	if(!obj_TargetFile.exists())
	{
		try {
			obj_TargetFile.create(0x00,0644);
		} catch (e) { alert(e); }
	}
	//new persitence object
	try {
		obj_Persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
	} catch (e) { alert(e);}

	//save file to target
	obj_Persist.saveURI(obj_URI,null,null,null,null,obj_TargetFile);
	alert("finished downloading " + xmlfile + " Please restart browser");
	
	//Update the lastrun Date
//	biobar_updateRunDate();
}

function biobar_updateRunDate() {
	var biobarprefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("biobar.");
	var biobar_updateDate = biobar_getDate();
	if(!biobarprefs.prefHasUserValue("lastrun.date")) {
		biobarprefs.setIntPref("lastrun.date",biobar_updateDate);
	} else {
		biobarprefs.setIntPref("lastrun.date", biobar_updateDate);
	}
}

function doBiobarURL(SearchTerm)
{
	var biobarPage = null;
	const biobarprefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("biobar.");
	if (biobarprefs.getCharPref("tab.preference") == "NewTab")
	{
		const newTab = getBrowser().addTab(SearchTerm);
		getBrowser().selectedTab = newTab;
	} else {
		_content.location.href = SearchTerm;
	}
}

function biobar_getDate()
{	
	var date = new Date();
	var year = date.getYear();
	if(year<1000) year +=1900;
	var day = date.getDate();
	if(day<10) day="0"+day;
	var month = date.getMonth();
	month +=1;
	date=(year+""+month+""+day);
	return(date);
}
